.386
.model flat,stdcall
option casemap:none

include MouseOver.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	mov		CommandLine,eax
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,NULL
	mov		wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

ButtonProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	rect:RECT

	mov		eax,uMsg
	.if eax==WM_MOUSEMOVE
		invoke GetCapture
		.if eax!=hBtn1 && eax!=hBtn2
			; The mouse has entered the button
			invoke SetCapture,hWin
			invoke GetWindowLong,hWin,GWL_ID
			.if eax==1001
				invoke SetDlgItemText,hWnd,1010,offset szOver1
			.elseif eax==1002
				invoke SetDlgItemText,hWnd,1010,offset szOver2
			.endif
		.else
			; Check if mouse is still on button
			invoke GetClientRect,hWin,addr rect
			mov		edx,lParam
			movzx	eax,dx
			shr		edx,16
			.if eax>rect.right || edx>rect.bottom
				; The mouse has left the button
				invoke ReleaseCapture
				invoke SetDlgItemText,hWnd,1010,0
			.endif
		.endif
	.else
		invoke CallWindowProc,lpOldButtonProc,hWin,uMsg,wParam,lParam
	.endif
	ret

ButtonProc endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		; Get handle of main window
		mov		eax,hWin
		mov		hWnd,eax
		; Get handle of buttons
		invoke GetDlgItem,hWin,1001
		mov		hBtn1,eax
		invoke GetDlgItem,hWin,1002
		mov		hBtn2,eax
		; Subclass the buttons
		invoke SetWindowLong,hBtn1,GWL_WNDPROC,offset ButtonProc
		mov		lpOldButtonProc,eax
		invoke SetWindowLong,hBtn2,GWL_WNDPROC,offset ButtonProc
	.elseif eax==WM_COMMAND
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		.if edx==BN_CLICKED
			.if eax==IDM_FILE_EXIT
				invoke SendMessage,hWin,WM_CLOSE,0,0
			.elseif eax==IDM_HELP_ABOUT
				invoke ShellAbout,hWin,addr AppName,addr AboutMsg,NULL
			.endif
		.endif
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

end start
